<?php
function headline_ext_css_generate_arr( $selector, $array, $save=false, $echo=true ) {
	$return = '';
	if ($array) {
		foreach ($array as $key => $style) {
			$mod = get_theme_mod($key);
			if ( ! empty( $mod ) ) {
				$return = $style . ':' . $mod . ';' . "\n";
			}
		}
		$return = $selector . '{' . $return . "}\n";
	}
	 if ($save) {
		 $all_css = get_option('headline_ext_css');
		 $all_css = $all_css . $return;
		 update_option('headline_ext_css',$all_css);
	 }
	 if ( $echo ) {
		echo $return;
	 }
}

function headline_ext_css_generate( $selector, $style, $mod_name, $save=false , $echo=false , $prefix='', $postfix='') {
  $return = '';
  $mod = get_theme_mod($mod_name);
  if ( ! empty( $mod ) ) {
	 $return = sprintf('%s { %s:%s; }',
		$selector,
		$style,
		$prefix.$mod.$postfix
	 );
	 if ($save) {
		 $all_css = get_option('headline_ext_css');
		 $all_css = $all_css . $return . "\n";
		 update_option('headline_ext_css',$all_css);
	 }
	 if ( $echo ) {
		echo $return;
	 }
  }
  return $return;
}

function headline_ext_css_db_reset() {
	update_option('headline_ext_css','');
}
function headline_ext_css_generate_media($return,$save=false,$echo=false) {
	if ($save) {
		 $all_css = get_option('headline_ext_css');
		 $all_css = $all_css . $return . "\n";
		 update_option('headline_ext_css',$all_css);
	}
	if ($echo) {
		echo $return;
	}
	return $return;
}
function headline_ext_css_output_temp($save,$echo) {

	if ($echo == true) {
		echo ' <style type="text/css">';
	}
	if ($save == true) {
		headline_ext_css_db_reset();
	}
	$cs = get_theme_mod('color_style');
	if ($cs) {
		$cs = '.' . $cs . ' ';
	}
	$color_active = get_theme_mod('color_active','yes');
	if ($color_active == 'yes') {
	   // COLOR //
	   // Global 
	   headline_ext_css_generate('body', 'color', 'global_color', $save, $echo );  
	   
	   headline_ext_css_generate($cs . 'a ,' . $cs . ' a:visited ,' . $cs .' a:active', 'color', 'link_color', $save, $echo );  
	   headline_ext_css_generate($cs . '.entry-title a:hover', 'color', 'link_color', $save, $echo );  
	   headline_ext_css_generate($cs . '.widget .widget-title', 'color', 'link_color', $save, $echo );  
	   headline_ext_css_generate($cs . '.search-form .search-submit', 'background-color', 'link_color', $save, $echo );
	   //headline_ext_css_generate($cs . 'button, [type="button"], [type="reset"], [type="submit"]', 'background-color','link_color', $save, $echo );
	   headline_ext_css_generate($cs . '.widget li > a', 'color', 'link_color', $save, $echo );  
	   
	   headline_ext_css_generate($cs . 'a:hover','color','link_hover_color', $save, $echo );  
	   headline_ext_css_generate($cs . '.entry-title a','color','link_hover_color', $save, $echo ); 
	   headline_ext_css_generate($cs . ' .page-links a:hover','background-color','link_hover_color', $save, $echo );
	   headline_ext_css_generate($cs . '.widget li > a:hover', 'color', 'link_hover_color', $save, $echo );  
	   
	   headline_ext_css_generate($cs . 'blockquote','color','blockquote_color', $save, $echo );  
	   headline_ext_css_generate($cs . 'blockquote','border-color','blockquote_border_color', $save, $echo );
	   headline_ext_css_generate($cs . '.right-sidebar .content-area','border-color','border_right_color', $save, $echo );
	   headline_ext_css_generate($cs . '.right-sidebar .blog-article article','border-color','border_bottom_color', $save, $echo );
	   headline_ext_css_generate($cs . '.post.sticky','background-color','sticky_bg_color', $save, $echo );
	   headline_ext_css_generate($cs . '.widget .widget-title', 'color', 'widgetright_title_color', $save, $echo ); 
	   headline_ext_css_generate($cs . '.widget li > a', 'color', 'widgetright_link_color', $save, $echo ); 
	   headline_ext_css_generate($cs . '.widget li > a:hover', 'color', 'widgetright_link_color_hover', $save, $echo );  

	   
	   headline_ext_css_generate($cs . '.post.sticky','background-color','sticky_bg_color', $save, $echo );  
	   headline_ext_css_generate('.entry-meta > span, .entry-footer > span','color','entry_span_color', $save, $echo ); 
	   
	   // HEADER
	   headline_ext_css_generate($cs . '.site-title a', 'color', 'site_title_color', $save, $echo );  
	   headline_ext_css_generate($cs . '.site-title a:hover', 'color', 'site_title_color_hover', $save, $echo );  
	   
	   // MENU
	   headline_ext_css_generate_media('@media (min-width: 768px) {', $save, $echo ); 
	   
			//MENU
			headline_ext_css_generate($cs . '.main-navigation-container','background-color','menu_bg_color', $save, $echo ); 
			headline_ext_css_generate($cs . '.main-navigation div > ul > li > a','color','menu_link1_color', $save, $echo ); 
			headline_ext_css_generate($cs . '.main-navigation .menu > .current_page_ancestor > a,'. $cs  .' .main-navigation .menu > .current-menu-item > a','color','menu_link1_color_selected', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation .menu > .current_page_ancestor > a,'. $cs  .' .main-navigation .menu > .current-menu-item > a','background-color','menu_link1_bg_color_selected', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation div > ul > li > a:hover','color','menu_link1_color_selected', $save, $echo ); 
			headline_ext_css_generate($cs . '.main-navigation div > ul > li > a:hover ,' . $cs . '.main-navigation div > ul > li:hover > a','background-color','menu_link1_bg_color_selected', $save, $echo ); 
			//MENU SECOND
			headline_ext_css_generate($cs . '.main-navigation ul','background-color','menu_bg2_color', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation ul ul li a','border-color','menu_link2_border_color', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation ul ul li a','color','menu_link2_color', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation ul ul li a:hover','color','menu_link2_color_hover', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation ul ul .current-menu-item > a','color','menu_link2_color_selected', $save, $echo );
	   headline_ext_css_generate_media('}', $save, $echo ); 
	   
	   // MENU RESPONSIVE
		headline_ext_css_generate_media('@media (max-width: 768px) {', $save, $echo ); 
			headline_ext_css_generate($cs . '.main-navigation-container','background-color','menuresponsive_bg_color', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation div > ul','background-color','menuresponsive_link_bg_color', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation ul a','color','menuresponsive_link_color', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation ul a:hover, '. $cs .' .main-navigation .current_page_item > a','color','menuresponsive_link_color_hover', $save, $echo );
			headline_ext_css_generate($cs . '.main-navigation ul a','border-color','menuresponsive_link_border_color', $save, $echo );
	    headline_ext_css_generate_media('}', $save, $echo ); 
	// COLOR ENDS//	
	}
	
	$font_active = get_theme_mod('font_active','yes');
	if ($font_active == 'yes') {
	// FONT //
		// GLOBAL FONT
		headline_ext_css_generate_arr(
			'body',
			array(
				'body_font_size' => 'font-size',
				'body_font_family' => 'font-family'
			),
			$save,
			$echo
		);
		// HEADER FONT
		headline_ext_css_generate_arr(
			'.site-title',
			array(
				'site_title_font_size' => 'font-size'
			),
			$save,
			$echo
		);
		headline_ext_css_generate_arr(
			'.site-description',
			array(
				'site_description_font_size' => 'font-size'
			),
			$save,
			$echo
		);
		// HEADING FONT
		headline_ext_css_generate_arr(
			'h1,h2,h3,h4,h5,h6',
			array(
				'heading_font_family' => 'font-family'
			),
			$save,
			$echo
		);
		headline_ext_css_generate_arr(
			'h1',
			array(
				'h1_font_size' => 'font-size'
			),
			$save,
			$echo
		);
		headline_ext_css_generate_arr(
			'h2',
			array(
				'h2_font_size' => 'font-size'
			),
			$save,
			$echo
		);
		// POST FONT
		headline_ext_css_generate_arr(
			'h1.entry-title',
			array(
				'h1_entry_title_font_size' => 'font-size'
			),
			$save,
			$echo
		);
		headline_ext_css_generate_arr(
			'h2.entry-title',
			array(
				'h2_entry_title_font_size' => 'font-size'
			),
			$save,
			$echo
		);
	// FONT ENDS //
	}
	if ($save == true) {
		$all_css = get_option('headline_ext_css');
		//echo $all_css;
	}
	if ($echo == true) {
	echo '</style>';
	}
}

function headline_ext_css_output() {
	headline_ext_css_output_temp(false,true);
}
//add_action( 'wp_head' , 'headline_ext_css_output'); 

function headline_ext_css_style() {
	echo '<style>';
	$all_css = get_option('headline_ext_css');
	echo $all_css;
	echo '</style>';
}
add_action( 'wp_footer' , 'headline_ext_css_style'); 


add_action('customize_save_after', 'headline_ext_css_regen', 100);
add_action('after_switch_theme', 'headline_ext_css_regen'); 
function headline_ext_css_regen( $wp_customize ) {
	if ( is_customize_preview() ) {
		headline_ext_css_output_temp(true,false);
	}
}

function headline_ext_css_style_refresh() {
	echo '<div id="headline-ext-css-refresh">';
	echo '</div>';
}
add_action( 'wp_footer' , 'headline_ext_css_style_refresh'); 

function headline_ext_css_selective_refresh( $wp_customize ) {
	
	$refresh['#headline-ext-css-refresh']['title'] = 'css';
    $refresh['#headline-ext-css-refresh']['render_callback'] = 'headline_ext_css_output';
	$array = [];
	$i = 0;
	foreach ( headline_exts_customizer_get_data_font_color() as $section_name => $section_data ) {
		foreach ( (array) $section_data['fields'] as $field_name => $field_data ) {
			$array[$i] = $field_name;
			$i++;
		}
	}
    $refresh['#headline-ext-css-refresh']['fields'] = $array;
	foreach ( $refresh as $item ) {        
        $segment = $item['fields'];
        if ( ($item['title']) !== 'false') {        
            foreach ($segment as $key ) {
                $wp_customize->get_setting($key)->transport         = 'postMessage';
            }        
        }
    }

    if (! isset($wp_customize->selective_refresh) ) {
        //return;
    }
    
    
    foreach ( $refresh as $key => $item ) {
        
        $func = $item['render_callback'];
        $segment = $item['fields'];
        if ( ($item['title']) !== 'false') {  
            foreach ( $segment as $key2 ) {
            
                $wp_customize->selective_refresh->add_partial(
                    $key2, array(
                    'selector' => $key,
                    'render_callback' => $func,
                    'container_inclusive' => false,
                    'fallback_refresh' => true
                    ) 
                );
            }
        }
        
    }
	
}
add_action('customize_register', 'headline_ext_css_selective_refresh');